/******************** (C) COPYRIGHT  iCreateǶʽ **************
 * ļ  flash_eeprom.c
 *     FlashڲData ROMдʵ   
 * ʵƽ̨STM8
 * 汾  V2.1.0
 *       QQ779814207
 *     
 * Ա    http://shop71177993.taobao.com/
 * ޸ʱ 2012-12-10
*******************************************************************************/

/* ϵͳͷļ */

/* Զͷļ */
#include "flash_eeprom.h"

/* Զ */

/* Զ */

/* ȫֱ */


/*******************************************************************************
 * : WriteMultiBlockByte
 * : дBlockֽ
 * β: BlockStartAddress    ֽڱдBlock׵ַ
         FLASH_MemType        FLASH Memory
         FLASH_ProgMode       FLASH ģʽ
         Buffer               Ҫдflash eeprom ֽ
         BlockNum             Ҫдflash eeprom Block
 * : 
 * ˵: ÿͺŵEEPROMĴСһô˺ʱҪע⽫Ҫдֽ
         ĴСǷ񳬹ͺŵEEPROMĵַ
         EEPROMͺSTM8S208, STM8S207, STM8S007, STM8AF52Ax, STM8AF62Ax 
         EEPROMĵַǴ0x0040000x0047ff2048Byte,ÿBlock128Byte,һ16Block.
         EEPROMͺSTM8S105, STM8S005, STM8AF626x
         EEPROMĵַǴ0x0040000x0043ff1024Byte,ÿBlock128Byte,һ8Block.
         СEEPROMͺSTM8S103, STM8S003, STM8S903 
         EEPROMĵַǴ0x0040000x00427f1024Byte,ÿBlock64Byte,һ10Block.

 ******************************************************************************/
void WriteMultiBlockByte(BlockStartAddress_TypeDef BlockStartAddress,FLASH_MemType_TypeDef FLASH_MemType, 
                FLASH_ProgramMode_TypeDef FLASH_ProgMode, uint8_t *Buffer,uint8_t BlockNum)
{
  uint8_t  BlockNum_Temp;
  /*  flash data eeprom memory */
  FLASH_Unlock(FLASH_MEMTYPE_DATA);
  /* ȴ Data EEPROM area ־λλ*/
  while (FLASH_GetFlagStatus(FLASH_FLAG_DUL) == RESET)
        ;
  for(BlockNum_Temp=BlockStartAddress;BlockNum_Temp<BlockNum;BlockNum_Temp++)
  {
    if(BlockNum_Temp>FLASH_DATA_BLOCKS_NUMBER)
      break;
    FLASH_ProgramBlock(BlockNum_Temp, FLASH_MemType, FLASH_ProgMode,Buffer+BlockNum_Temp*FLASH_BLOCK_SIZE);
    FLASH_WaitForLastOperation(FLASH_MemType);
  }
  
  FLASH_Lock(FLASH_MEMTYPE_DATA);/*Ҫ*/

}

/*******************************************************************************
 * : ReadMultiBlockByte
 * : Blockֽ
 * β: BlockStartAddress    Block׵ַ
         BlockNum             Block
         ReadBlockByte[]      Ŷֽڵ       
 * : 
 * ˵: ÿͺŵEEPROMĴСһô˺ʱҪע⽫Ҫдֽ
         ĴСǷ񳬹ͺŵEEPROMĵַ
         EEPROMͺSTM8S208, STM8S207, STM8S007, STM8AF52Ax, STM8AF62Ax 
         EEPROMĵַǴ0x0040000x0047ff2048Byte,ÿBlock128Byte,һ16Block.
         BlockNum @ 1~16
         EEPROMͺSTM8S105, STM8S005, STM8AF626x
         EEPROMĵַǴ0x0040000x0043ff1024Byte,ÿBlock128Byte,һ8Block.
         BlockNum @ 1~8
         СEEPROMͺSTM8S103, STM8S003, STM8S903 
         EEPROMĵַǴ0x0040000x00427f1024Byte,ÿBlock64Byte,һ10Block.
         BlockNum @ 1~10

 ******************************************************************************/
void ReadMultiBlockByte(BlockStartAddress_TypeDef BlockStartAddress,uint8_t BlockNum,
                        uint8_t ReadBlockByte[])
{
  uint32_t add, start_add, stop_add;
  start_add = FLASH_DATA_START_PHYSICAL_ADDRESS+(u32)((BlockNum-1)*FLASH_BLOCK_SIZE);
  stop_add = FLASH_DATA_START_PHYSICAL_ADDRESS + (u32)(BlockNum*FLASH_BLOCK_SIZE);
 
  for (add = start_add; add < stop_add; add++)
      ReadBlockByte[add-FLASH_DATA_START_PHYSICAL_ADDRESS]=FLASH_ReadByte(add);
 
  
}



/*************** (C) COPYRIGHT iCreateǶʽ *****END OF FILE****/