
#ifndef   __LED_H
#define  __LED_H

#include "stm8s.h"
 
typedef struct
  {
     uint16_t set_count;
     uint16_t set_mode;
     uint16_t T1x;
     uint16_t T1b;
     uint16_t T2x;
     uint16_t T2b;
     uint16_t  Nx;
  }INT16_memory;

extern INT16_memory    memory;
extern unsigned long  TimingDelay;
extern unsigned char TRIG_OK;
extern unsigned char STRAT_OK;
extern unsigned char MODESET_OK ;
extern unsigned char SET_OK ;
extern unsigned char ADD_OK ;
extern unsigned char DEC_OK ;
  

//LEDƶ
#define LED1_GPIO_PORT  (GPIOD)
#define LED1_GPIO_PINS  (GPIO_PIN_2)
#define LED2_GPIO_PORT  (GPIOD)
#define LED2_GPIO_PINS  (GPIO_PIN_3)
//ܿŶ
#define TM1620_STB_GPIO_PORT  (GPIOD)
#define TM1620_STB_GPIO_PINS  (GPIO_PIN_4)
#define TM1620_CLK_GPIO_PORT  (GPIOD)
#define TM1620_CLK_GPIO_PINS  (GPIO_PIN_5)
#define TM1620_DIN_GPIO_PORT  (GPIOD)
#define TM1620_DIN_GPIO_PINS  (GPIO_PIN_6)
//Ŷ
#define KEY_SET_GPIO_PORT  (GPIOC)
#define KEY_SET_GPIO_PINS  (GPIO_PIN_3)
#define KEY_ADD_GPIO_PORT  (GPIOC)
#define KEY_ADD_GPIO_PINS  (GPIO_PIN_4)
#define KEY_DEC_GPIO_PORT  (GPIOC)
#define KEY_DEC_GPIO_PINS  (GPIO_PIN_5)
//Ŷ
#define INT_GPIO_PORT  (GPIOB)
#define INT_GPIO_PINS  (GPIO_PIN_5)
//Ŷ
#define OUT_GPIO_PORT  (GPIOC)
#define OUT_GPIO_PINS  (GPIO_PIN_7)


#define TM1620_STB_1 GPIO_WriteHigh(TM1620_STB_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_STB_GPIO_PINS)
#define TM1620_STB_0 GPIO_WriteLow (TM1620_STB_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_STB_GPIO_PINS)
#define TM1620_CLK_1 GPIO_WriteHigh(TM1620_CLK_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_CLK_GPIO_PINS)
#define TM1620_CLK_0 GPIO_WriteLow (TM1620_CLK_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_CLK_GPIO_PINS)
#define TM1620_DIN_1 GPIO_WriteHigh(TM1620_DIN_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_DIN_GPIO_PINS)
#define TM1620_DIN_0 GPIO_WriteLow (TM1620_DIN_GPIO_PORT, (GPIO_Pin_TypeDef)TM1620_DIN_GPIO_PINS)

#define led1_liang     GPIO_WriteHigh(LED1_GPIO_PORT, (GPIO_Pin_TypeDef)LED1_GPIO_PINS) 
#define led1_mie       GPIO_WriteLow(LED1_GPIO_PORT, (GPIO_Pin_TypeDef)LED1_GPIO_PINS)

#define led2_liang     GPIO_WriteHigh(LED2_GPIO_PORT, (GPIO_Pin_TypeDef)LED2_GPIO_PINS) 
#define led2_mie       GPIO_WriteLow(LED2_GPIO_PORT, (GPIO_Pin_TypeDef)LED2_GPIO_PINS)
     
#define jdq_xihe         GPIO_WriteHigh(OUT_GPIO_PORT, (GPIO_Pin_TypeDef)OUT_GPIO_PINS)   
#define jdq_duankai   GPIO_WriteLow(OUT_GPIO_PORT, (GPIO_Pin_TypeDef)OUT_GPIO_PINS)   
#define jdq_qufan      GPIO_WriteReverse(OUT_GPIO_PORT, (GPIO_Pin_TypeDef)OUT_GPIO_PINS)
#define jdq_zhuangtai  GPIO_ReadInputPin(OUT_GPIO_PORT, (GPIO_Pin_TypeDef)OUT_GPIO_PINS)  

void delay_ms(unsigned int ms);
void Delay(uint16_t nCount) ; 


#endif